#define KBBIOS_TABLE_FILE 1

#include "kbbios.h"

/*
 * the key-definition table contains scancode information used by the
 * scancode processor.  Each table entry stores the following data :
 *
 *	1) Make code (in octal base-8 code)
 *	2) Break code (in octal base-8 code)
 *	3) equivalent ASCII code (0==none)
 *	4) enumeration ID code (from the enumerated type "Keyboard_codes")
 *
 */

const Key_definition kb_keys[] = {
	KEY_A, 
		"\034", "\360\034", 'a', 'A',

	KEY_B, 
		"\062", "\360\062", 'b', 'B',

	KEY_C, 
		"\041", "\360\041", 'c', 'C',

	KEY_D, 
		"\043", "\360\043", 'd', 'D',

	KEY_E, 
		"\044", "\360\044", 'e', 'E',
	
	KEY_F, 
		"\053", "\360\053", 'f', 'F',

	KEY_G, 
		"\064", "\360\064", 'g', 'G',

	KEY_H,
		"\063", "\360\063", 'h', 'H',

	KEY_I,
		"\103", "\360\103", 'i', 'I',

	KEY_J,
		"\073", "\360\073", 'j', 'J',

	KEY_K,
		"\102", "\360\102", 'k', 'K',

	KEY_L,
		"\113", "\360\113", 'l', 'L',

	KEY_M,
		"\072", "\360\072", 'm', 'M',

	KEY_N,
		"\061", "\360\061", 'n', 'N',

	KEY_O,
		"\104", "\360\104", 'o', 'O',

	KEY_P,
		"\115", "\360\115", 'p', 'P',

	KEY_Q,
		"\025", "\360\025", 'q', 'Q',

	KEY_R,
		"\055", "\360\055", 'r', 'R',

	KEY_S,
		"\033", "\360\033", 's', 'S', 

	KEY_T,
		"\054", "\360\054", 't', 'T',

	KEY_U,
		"\074", "\360\074", 'u', 'U',

	KEY_V,
		"\052", "\360\052", 'v', 'V',

	KEY_W,
		"\035", "\360\035", 'w', 'W',

	KEY_X,
		"\042", "\360\042", 'x', 'X',

	KEY_Y,
		"\065", "\360\065", 'y', 'Y',

	KEY_Z,
		"\032", "\360\032", 'z', 'Z',

	KEY_0,
		"\105", "\360\105", '0', ')',

	KEY_1,
		"\026", "\360\026", '1', '!',

	KEY_2,
		"\036", "\360\036", '2', '@',

	KEY_3,
		"\046", "\360\046", '3', '#',

	KEY_4,
		"\045", "\360\045", '4', '$',

	KEY_5,
		"\056", "\360\056", '5', '%',

	KEY_6,
		"\066", "\360\066", '6', '^',

	KEY_7,
		"\075", "\360\075", '7', '&',

	KEY_8,
		"\076", "\360\076", '8', '*',

	KEY_9,
		"\106", "\360\106", '9', '(',

	KEY_TICK, /* '`' */
		"\016", "\360\016", '\140', '~',

	KEY_DASH,
		"\116", "\360\116", '-', '_',

	KEY_EQUAL,
		"\125", "\360\125", '=', '+',

	KEY_BSLASH, /* '\' */
		"\135", "\360\136", '\\', '|',

	KEY_FSLASH, /* '/' */
		"\112", "\360\112", '/', '?',

	KEY_BACKSPACE,
		"\146", "\360\146", '\b', '\b',

	KEY_SPACE, /* SPACEBAR */
		"\051", "\360\051", ' ', ' ',

	KEY_TAB,
		"\015", "\360\015", '\t', '\t',

	KEY_CAPSLOCK,
		"\130", "\360\130", '\0', '\0',

	KEY_LSHIFT,
		"\022", "\360\022", '\0', '\0',

	KEY_LCTRL,
		"\024", "\360\024", '\0', '\0',

/*	KEY_LWIN, // WIN95*/

	KEY_LALT,
		"\021", "\360\021", '\0', '\0',

	KEY_RSHIFT,
		"\131", "\360\131", '\0', '\0',

	KEY_RCTRL,
		"\340\024", "\340\360\024", '\0', '\0',

/*	KEY_RWIN, // WIN95*/

	KEY_RALT,
		"\340\021", "\340\360\021", '\0', '\0',

/*	KEY_APPS, // WIN95*/

	KEY_ENTER,
		"\132", "\360\132", '\n', '\n',

	KEY_ESC,
		"\166", "\360\166", '\0', '\0',

	KEY_LBRACKET, /* '[' */
		"\124", "\360\124", '[', '{',

	KEY_RBRACKET, /* ']' */
		"\133", "\360\133", ']', '}',

	KEY_SEMICOLON, /* ';' */
		"\114", "\360\114", ';', ':',

	KEY_APPOSTROPHE, /* ''' */
		"\122", "\360\122", '\'', '\"',

	KEY_COMMA, /* ',' */
		"\101", "\360\101", ',', '<',

	KEY_PERIOD, /* '.' */
		"\111", "\360\111", '.', '>',

	KEY_ENDOFTABLE, /* dummy entry, terminates table*/
		"", "", '\0', '\0'
	};
/*
	KEY_F1,
	KEY_F2,
	KEY_F3,
	KEY_F4,
	KEY_F5,
	KEY_F6,
	KEY_F7,
	KEY_F8,
	KEY_F9,
	KEY_F10,
	KEY_F11,
	KEY_F12,
	KEY_INSERT,
	KEY_HOME,
	KEY_PAGEUP,
	KEY_DELETE,
	KEY_END,
	KEY_PAGEDOWN,
	KEY_UPARROW,
	KEY_LEFTARROW,
	KEY_DOWNARROW,
	KEY_RIGHTARROW,
*/
